import processing.serial.*;
Serial myPort;

int v,v0,xpos;
int screen_height,screen_width;
PFont font;
long st,st0;
String port;
String Data[];
int dcnt=0;
float temp,temp0,maxtemp,mintemp,gain,offset;
String sstring;
String mstr="AVF";
int mode=68;

void setup(){
  
  maxtemp=35;  // maximum temperature value of draw area
  mintemp=25;  // minimum

  //port="COM13";myPort=new Serial(this,port,57600);
  myPort=new Serial(this,Serial.list()[0],57600);
  myPort.bufferUntil('\n');
  
  screen_width=900;
  screen_height=400;
  size(900,400);
  font = loadFont("AgencyFB-Reg-24.vlw");
  xpos=0;
  redraw();
  Data=new String[3600];
  gain=400.0/(maxtemp-mintemp);
}

void draw(){  
  st=millis()/1000;
  if(st!=st0){

  
    // show temperature
    stroke(255, 255, 255); fill(255, 255, 255); rect(0, 0, 100, 65);
    textFont(font,24); 
    fill(0, 102, 153); text(mstr, 10, 30);
    fill(0, 102, 153); text(temp, 10, 60);
    
    // draw line 
    stroke(255, 100, 100); 
    int y,y0;
    y=screen_height-int((temp-mintemp)*gain);
    y0=screen_height-int((temp0-mintemp)*gain);
    line(xpos-1,y0,xpos,y);
    xpos++;
    if(xpos>screen_width){xpos=0;redraw();}
    
    // save temperature
    String str;
    str=dcnt+","+temp;
    Data[dcnt]=str;   
    dcnt++;       
    st0=st;
    if(dcnt%10==0){
      str=" , ";
      Data[dcnt]=str;
      saveStrings("result.csv", Data);
    }
    temp0=temp;
  }
}

// refresh screen
void redraw(){
  background(255);
  stroke(0, 0, 0); 
  fill(255, 255, 255); 
  for(int i=0;i<15;i++){
    line(i*60, 0, i*60, 400);
  }
}

// get data from arduino
void serialEvent(Serial p){
  
  sstring=myPort.readStringUntil('\n');
  String param[]=split(sstring,",");
  
  temp=float(param[0]);
  print(sstring);
  v=int(param[0])*10;
  myPort.write(mode);
}

// mode change by key press
void keyPressed()
{ 
    if (key == '1'){mode=65;mstr="NF";}
    if (key == '2'){mode=66;mstr="AF";}
    if (key == '3'){mode=67;mstr="VF";}
    if (key == '4'){mode=68;mstr="AVF";}
}